// Spice_SOM_HowtoUse.cpp
//

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <math.h>
#include <vector>
#include <omp.h>
#include "include/spice_som_lib.h"
using namespace SpiceNeuro;
int main()
{
   const int nxNodes = 10;
   const int nyNodes = 10;
   const int iDataLength = 4;
   const int nDataSets = 150;
   SpiceS *som = new SpiceS(nxNodes, nyNodes, iDataLength, nDataSets);
   som->LoadTrainingData("iris_for_som_150_data_4_inputs.txt.dat");
   som->ResetRandomWeight();
   som->BuildingWinnerTable();
   som->SaveWinnerTable2CsvFile("iris_map_before_trainining.csv");

   som->Training(NF_Linear, 10);
   som->BuildingWinnerTable();
   som->SaveWinnerTable2CsvFile("iris_map_after_training.csv");
   som->saveWeight("iris_weight.dat");

   som->ResetRandomWeight();
   som->BuildingWinnerTable();
   som->SaveWinnerTable2CsvFile("iris_map_after_reset.csv");

   som->loadWeight("iris_weight.dat");
   som->BuildingWinnerTable();
   som->SaveWinnerTable2CsvFile("iris_map_after_reload.csv");

	return 0;
}

